#!/usr/bin/env python
# -*- coding: utf-8 -*-
# erweitertEuler-Demo-mit-Feld.py
# © Claus Albowski

### Für schwazen Hintergrund auf True ändern
schwarz=False #True #

#### Importe:
import platform
versionsNummer=platform.python_version()[0]
if versionsNummer=='3':
    from tkinter import *
    import tkinter.messagebox as messagebox
else:
    from Tkinter import *
    import tkMessageBox as messagebox
from math import *

class GrafikFenster(Frame):
    
    def __init__(self, master=None, breite=500, hoehe=500, schritte=3):
        '''breite und hoehe definieren die Abmessungen der Zeichenflaeche
        Vorgabe ist 500 x 500 , also je 25 Platz'''
        Frame.__init__(self,master)
        self.breite = breite
        self.hoehe = hoehe
        self.ursprung=(25, hoehe-25)
        self.schritt=0
        self.anzahlSchritte=schritte
        self.anzahlWerte = 5 # y-Achseinteilung mit 10,20,30,40,50
        self.term='0.3*B'
        self.startwert=15.0
        exec('B='+str(self.startwert),globals()) # Bestandswert als globale Variable
        self.pack()
        ## fuer Dunkelmodus:
        if schwarz: self.fg,self.bg='white','black'
        else: self.fg,self.bg='black','white'
        
        top = self.winfo_toplevel()
        ## Menübereich
        self.menuBar = Menu(top)
        top['menu'] = self.menuBar
        #### Aktions-Menu
        self.aktionSubMenu = Menu(self.menuBar)
        self.menuBar.add_cascade(label='Aktion', menu=self.aktionSubMenu)
        self.aktionSubMenu.add_command(label='Start', command=self.onStart)
        self.aktionSubMenu.add_command(label='Schritt', command=self.onSchritt)
        self.aktionSubMenu.add_command(label=u'Term ändern', command=self.onTerm)
        self.aktionSubMenu.add_command(label='Beenden', command=self.quit)
        #### Hilfe-Menu
        self.hilfeSubMenu = Menu(self.menuBar)
        self.menuBar.add_cascade(label='Hilfe', menu=self.hilfeSubMenu)
        self.hilfeSubMenu.add_command(label='Hilfe', command=self.onHilfeText)

        #### Widgets:  Einsatz des grid - Geometriemanagers
        # 1. Zeile: Button
        self.schrittButton = Button(self,text="Start",command=self.onStart)
        self.schrittButton.grid(row=0,column=0)
        self.schrittButton = Button(self,text="Schritt",command=self.onSchritt)
        self.schrittButton.grid(row=0,column=1)
        self.termLabel = Label(self, text="Term:")
        self.termLabel.grid(row=0,column=2)
        self.termString = StringVar()
        self.termString.set(self.term)
        self.termEingabe = Entry(self,textvariable=self.termString,width=10)
        self.termEingabe.grid(row=0,column=3)
        self.termEingabe.bind("<Return>", self.onTerm)
        self.endeButton = Button(self,text="Beenden",command=self.quit)
        self.endeButton.grid(row=0,column=4)
        # 2. Zeile: Zeichenfenster
        self.zeichenfenster = Canvas(self,width=self.breite,height=self.hoehe,bg=self.bg)
        self.zeichenfenster.grid(row=1,column=0,columnspan=5)
        self.KoordinatensystemZeichnen(self.zeichenfenster)
        self.FeldZeichnen(self.zeichenfenster)

    #### Aktions-Menu
    def onStart(self, evt=None):
        self.zeichenfenster.delete('Zeichnung') # alte Darstellung loeschen
        self.schritt=0
        exec('B='+str(self.startwert),globals()) # Bestandswert als globale Variable
        
    def onSchritt(self, evt=None):
        if self.schritt>=self.anzahlSchritte:
            messagebox.showinfo('Info', u'fertig; ggf. neu starten')
            return
        global B
        self.schritt+=1
        zf=self.zeichenfenster
        zf.delete('zwischen')
        B0=B # B(t=0)
        Aenderung=eval(self.term)
        B1=B+Aenderung
        x0,y0=self.xZuBild(self.schritt-1), self.yZuBild(B0)
        x1,y1=self.xZuBild(self.schritt), self.yZuBild(B1)
        B=B1
        zf.create_line(x0,y0,x1,y1,tag='Zeichnung',width=2,fill=self.fg)
        
    def KoordinatensystemZeichnen(self,zf):
        zf.create_line(0.0,self.ursprung[1],self.breite,self.ursprung[1],fill=self.fg)
        zf.create_line(self.ursprung[0],0.0,self.ursprung[0],self.hoehe,fill=self.fg)
        ## Beschriftung y-Achse:
        for i in range(self.anzahlWerte):
            x,y=self.xZuBild(0),self.yZuBild(10+10*i)
            zf.create_line(x-10, y, x+10, y, tag='Achsen',fill=self.fg)
            zf.create_text(x-10, y, text=str(10+i*10),anchor=N,tag='Achsen',fill=self.fg)  ## Beschriftung x -Achse:
        zf.create_text(self.ursprung[0], self.ursprung[1], text='0',anchor=NE,tag='Achsen',fill=self.fg)
        anz=self.anzahlSchritte
        for i in range(1,self.anzahlSchritte+1):
            pos=(self.xZuBild(i), self.yZuBild(0))
            zf.create_line(pos[0], pos[1]-10, pos[0], pos[1]+10, tag='Achsen',fill=self.fg)
            zf.create_text(pos[0], pos[1]+10, text=str(i),anchor=N,tag='Achsen',fill=self.fg)

    def FeldZeichnen(self,zf):
        teile=10
        dx=int((self.breite-50)/self.anzahlSchritte/teile) # Schrittweite
        for b in range(1,self.anzahlWerte*10+2):
            B=b
            Aenderung=eval(self.term)
            y=self.yZuBild(B)
            ye=self.yZuBild(B+Aenderung/2/teile)
            for x in range(self.ursprung[0],self.breite, dx):
                zf.create_line(x, y, x+dx/2, ye, fill='#666', tag='Feld')
        B=self.startwert
            
    def onTerm(self, evt=None):
        alterTerm=self.term
        try:
            term=self.termString.get()
            eval(term)
        except Exception:
            self.termString.set(self.term)
            return
        if alterTerm==term: return
        self.term=term
        self.zeichenfenster.delete('Feld')
        self.FeldZeichnen(self.zeichenfenster)
        self.onStart()
        
    def xZuBild(self,x_koordinate):
        '''x_koordinate aus [0,0.5,1,1,5,2,2.5,3,3.5,4]'''
        return self.ursprung[0]+x_koordinate*(self.breite-50)/self.anzahlSchritte
        
    def yZuBild(self,y_koordinate):
        '''Die Transformation der y-Koordinaten in Bildschirmkoordinaten passt
        auch die Koordinaten an die y-Richtung der Zeichenflaeche an.'''
        return self.ursprung[1]-y_koordinate*(self.hoehe-50)/10/self.anzahlWerte

    def onHilfeText(self):
        messagebox.showinfo('Info',
                              u'Starten der Demo mit "Schritt".\n'
                              u'Erneutes Starten der Demo\n aus dem Menue.\n'
                              +u'Beispiel ist exponentielles\n Wachstum mit Fluss 0.4*B.\n'
                              +u'Neuer Term:\n'
                              +u' Erst Term verändern,\n dann Menüpunkt aufrufen')


#### -----------------------------------------------------------------------
if __name__=='__main__':
    root = Tk()
    grafikfenster = GrafikFenster(master=root,breite=800, hoehe=500, schritte=4)
    grafikfenster.master.title('Demo zum Euler-Cauchy-Verfahren')
    grafikfenster.mainloop()
    try:
        grafikfenster.destroy()
        root.destroy()
    except Exception: pass
        
