#!/usr/bin/env python
# -*- coding: utf-8 -*-
# RungeKutta-Demo.py
# © Claus Albowski

### Für schwazen Hintergrund auf True ändern
schwarz=False #True #

#### Importe:
import platform
versionsNummer=platform.python_version()[0]
if versionsNummer=='3':
    from tkinter import *
    import tkinter.messagebox as messagebox
else:
    from Tkinter import *
    import tkMessageBox as messagebox
from math import *

class GrafikFenster(Frame):
    
    def __init__(self, master=None, breite=650, hoehe=500, schritte=3):
        '''breite und hoehe definieren die Abmessungen der Zeichenflaeche
        Vorgabe ist 650 x 500 , also je 20 Platz'''
        Frame.__init__(self,master)
        self.breite = breite
        self.hoehe = hoehe
        self.ursprung=(25, hoehe-25)
        self.schritt=1
        self.teilschritt=1
        self.Aenderung=0
        self.anzahlSchritte=schritte
        self.anzahlWerte = 5 # y-Achseinteilung mit 10,20,30,40,50
        self.term='0.4*B'
        self.startwert=11.0
        exec('B='+str(self.startwert),globals()) # Bestandswert als globale Variable
        self.m1,self.m2,self.m3,self.m4=0.0,0.0,0.0,0.0 # eigentlich m1*dt usw.
        self.pack()
        ## fuer Dunkelmodus:
        if schwarz: self.fg,self.bg='white','black'
        else: self.fg,self.bg='black','white'
        
        top = self.winfo_toplevel()
        ## Menübereich
        self.menuBar = Menu(top)
        top['menu'] = self.menuBar
        #### Aktions-Menu
        self.aktionSubMenu = Menu(self.menuBar)
        self.menuBar.add_cascade(label='Aktion', menu=self.aktionSubMenu)
        self.aktionSubMenu.add_command(label='Start', command=self.onStart)
        self.aktionSubMenu.add_command(label='Schritt', command=self.onSchritt)
        self.aktionSubMenu.add_command(label=u'Term ändern', command=self.onTerm)
        self.aktionSubMenu.add_command(label='Beenden', command=self.quit)
        #### Hilfe-Menu
        self.hilfeSubMenu = Menu(self.menuBar)
        self.menuBar.add_cascade(label='Hilfe', menu=self.hilfeSubMenu)
        self.hilfeSubMenu.add_command(label='Hilfe', command=self.onHilfeText)

        #### Widgets:  Einsatz des grid - Geometriemanagers
        # 1. Zeile: Button
        self.schrittButton = Button(self,text="Start",command=self.onStart)
        self.schrittButton.grid(row=0,column=0)
        self.schrittButton = Button(self,text="Schritt",command=self.onSchritt)
        self.schrittButton.grid(row=0,column=1)
        self.termLabel = Label(self, text="Term:")
        self.termLabel.grid(row=0,column=2)
        self.termString = StringVar()
        self.termString.set(self.term)
        self.termEingabe = Entry(self,textvariable=self.termString,width=10)
        self.termEingabe.grid(row=0,column=3)
        self.termEingabe.bind("<Return>", self.onTerm)
        self.endeButton = Button(self,text="Beenden",command=self.quit)
        self.endeButton.grid(row=0,column=4)
        # 2. Zeile: Zeichenfenster
        self.zeichenfenster = Canvas(self,width=self.breite,height=self.hoehe,bg=self.bg)
        self.zeichenfenster.grid(row=1,column=0,columnspan=5)
        self.KoordinatensystemZeichnen(self.zeichenfenster)

    #### Aktions-Menu
    def onStart(self, evt=None):
        self.zeichenfenster.delete('Zeichnung') # alte Darstellung loeschen
        self.schritt=1
        self.teilschritt=1
        exec('B='+str(self.startwert),globals()) # Bestandswert als globale Variable
        
    def onSchritt(self, evt=None):
        if self.schritt>self.anzahlSchritte:
            messagebox.showinfo('Info', u'fertig!\n ggf. neu starten')
            return
        global B
        zf=self.zeichenfenster
        if self.teilschritt==1:
            self.Teilschritt_1(zf)
        elif self.teilschritt==2:
            self.Teilschritt_2(zf)
        elif self.teilschritt==3:
            self.Teilschritt_3(zf)
        else:
            zf.delete('zwischen')
            zf.delete('Teilschritt_3')
            m=(self.m1+2*self.m2+2*self.m3+self.m4)/6.0
            x0,y0=self.xZuBild(self.schritt-1), self.yZuBild(B)
            x1,y1=self.xZuBild(self.schritt), self.yZuBild(B+m)
            zf.create_line(x0,y0,x1,y1,tags=['Zeichnung'],width=2,fill=self.fg)
            B=B+m
            self.schritt+=1
            self.teilschritt=0
        self.teilschritt+=1

    def Teilschritt_1(self,zf):
        global B
        B0=B # sichern
        self.m1=eval(self.term)
        Aenderung=self.m1/2.0
        B1=B+Aenderung
        x0,y0=self.xZuBild(self.schritt-1), self.yZuBild(B0)
        x1,y1=self.xZuBild(self.schritt-0.5), self.yZuBild(B1)
        zf.create_line(x0,y0,x1,y1,tags=['Zeichnung','zwischen'],fill='blue',width=2,dash=(5,2))
        B=B1
        self.m2=eval(self.term)
        Aenderung=self.m2/2.0
        x2,y2=self.xZuBild(self.schritt), self.yZuBild(B1+Aenderung)
        zf.create_line(x1,y1,x2,y2,tags=['Zeichnung','Teilschritt_1'],fill='red',width=2,dash=(5,2))
        B=B0 # zuruecksetzen

    def Teilschritt_2(self,zf):
        global B
        B0=B # sichern
        zf.delete('Teilschritt_1')
        x0,y0=self.xZuBild(self.schritt-1), self.yZuBild(B)
        B1=B+self.m2/2.0
        x1,y1=self.xZuBild(self.schritt-0.5), self.yZuBild(B1)
        zf.create_line(x0,y0,x1,y1,tags=['Zeichnung','zwischen'],fill='green',width=2,dash=(5,2))
        B=B1
        self.m3=eval(self.term)
        Aenderung=self.m3/2.0
        x2,y2=self.xZuBild(self.schritt), self.yZuBild(B1+Aenderung)
        zf.create_line(x1,y1,x2,y2,tags=['Zeichnung','Teilschritt_2'],fill='red',width=2,dash=(5,2))
        B=B0 # zuruecksetzen
        
    def Teilschritt_3(self,zf):
        global B
        B0=B # sichern
        zf.delete('Teilschritt_2')
        x0,y0=self.xZuBild(self.schritt-1), self.yZuBild(B)
        B1=B+self.m3
        x1,y1=self.xZuBild(self.schritt), self.yZuBild(B1)
        zf.create_line(x0,y0,x1,y1,tags=['Zeichnung','zwischen'],fill='magenta',width=2,dash=(5,2))
        B=B1
        self.m4=eval(self.term)
        x2,y2=self.xZuBild(self.schritt+1), self.yZuBild(B1+self.m4)
        zf.create_line(x1,y1,x2,y2,tags=['Zeichnung','Teilschritt_3'],fill='red',width=2,dash=(5,2))
        B=B0 # zuruecksetzen
        
    def KoordinatensystemZeichnen(self,zf):
        zf.create_line(0.0,self.ursprung[1],self.breite,self.ursprung[1],fill=self.fg)
        zf.create_line(self.ursprung[0],0.0,self.ursprung[0],self.hoehe,fill=self.fg)
        ## Beschriftung y-Achse:
        for i in range(self.anzahlWerte):
            x,y=self.xZuBild(0),self.yZuBild(10+10*i)
            zf.create_line(x-10, y, x+10, y, tag='Achsen',fill=self.fg)
            zf.create_text(x-10, y, text=str(10+i*10),anchor=N,tag='Achsen',fill=self.fg)
        ## Beschriftung x -Achse:
        ## Da bei Runge-Kutta auch die Punkte zu dt/2 benoetigt werden, werden die Stellen
        ## x: 0, dt/2, dt, 3dt/2, 2dt, 5dt/2, 3dt, 7dt/2, 4dt          verwendet
        zf.create_text(self.ursprung[0], self.ursprung[1], text='0',anchor=NE,tag='Achsen',fill=self.fg)
        anz=self.anzahlSchritte
        for i in range(1,self.anzahlSchritte+1):
            # halbe Werte
            pos=(self.xZuBild(i-0.5), self.yZuBild(0))
            zf.create_line(pos[0], pos[1]-10, pos[0], pos[1]+10, tag='Achsen',fill=self.fg)
            zf.create_text(pos[0], pos[1]+10, text=str(i-1)+'.5',anchor=N,tag='Achsen',fill=self.fg)
            # ganze Werte
            pos=(self.xZuBild(i), self.yZuBild(0))
            zf.create_line(pos[0], pos[1]-10, pos[0], pos[1]+10, tag='Achsen',fill=self.fg)
            zf.create_text(pos[0], pos[1]+10, text=str(i),anchor=N,tag='Achsen',fill=self.fg)

    def onTerm(self, evt=None):
        try:
            term=self.termString.get()
            eval(term)
        except Exception:
            self.termString.set(self.term)
            return
        self.term=term
        self.onStart()

    def xZuBild(self,x_koordinate):
        '''x_koordinate aus [0,0.5,1,1,5,2,2.5,3,3.5,4]'''
        return self.ursprung[0]+x_koordinate*(self.breite-50)/self.anzahlSchritte
        
    def yZuBild(self,y_koordinate):
        '''Die Transformation der y-Koordinaten in Bildschirmkoordinaten passt
        auch die Koordinaten an die y-Richtung der Zeichenflaeche an.'''
        return self.ursprung[1]-y_koordinate*(self.hoehe-50)/10/self.anzahlWerte

    def onHilfeText(self):
        messagebox.showinfo('Info',
                              u'Starten der Demo mit "Schritt".\n'
                              u'Erneutes Starten der Demo\n aus dem Menue.\n'
                              +u'Beispiel ist exponentielles\n Wachstum mit Fluss 0.5*B.\n'
                              +u'Neuer Term:\n'
                              +u' Erst Term verändern,\n dann Menüpunkt aufrufen')


#### -----------------------------------------------------------------------
if __name__=='__main__':
    root = Tk()
    grafikfenster = GrafikFenster(master=root, breite=950, hoehe=650, schritte=3)
    grafikfenster.master.title('Demo zum Runge-Kutta-Verfahren')
    grafikfenster.mainloop()
    try:
        grafikfenster.destroy()
        root.destroy()
    except Exception: pass
        
